=== modified file 'Makefile'
--- Makefile	2011-10-22 00:46:35 +0000
+++ Makefile	2011-08-17 22:46:35 +0000
@@ -5,7 +5,7 @@
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
 	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code
+#	-Wunreachable-code 
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.4.1
+version=1.3.1
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -65,9 +65,7 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@);\
-	LANG=en_US.UTF-8 MANWIDTH=80 man --warnings --encoding=UTF-8 \
-	--local-file $(notdir $@) >/dev/null)
+	$(MANPOST) $(notdir $@))
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
@@ -260,6 +258,12 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
+	@echo "#################################################################"
+	@echo "# NOTE: Please IGNORE the error about \"Could not open file      #"
+	@echo "# u'/var/run/mandos.pid'\" -  it is harmless and is caused by    #"
+	@echo "# the server not running as root.  Do NOT run \"make run-server\" #"
+	@echo "# server as root if you didn't also unpack and compile it thus. #"
+	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server

=== modified file 'NEWS'
--- NEWS	2011-10-15 16:48:03 +0000
+++ NEWS	2011-07-27 17:58:27 +0000
@@ -1,26 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.4.1 (2011-10-15)
-* Server
-** Make D-Bus properties settable again, and handle checkers
-   for disabled clients correctly.
-* Miscellaneous fixes to "pedantic" Lintian warnings
-
-Version 1.4.0 (2011-10-09)
-* README file migrated to manual page intro(8mandos).
-* Client:
-** Fixed warning about "rmdir: Directory not empty".
-* Server:
-** Default values changed: timeout 5 minutes, interval 2 minutes.
-** Clients gets an expiration extension when receiving a password,
-   controlled by new "extended_timeout" setting.
-** New domain name: "fukt.bsnet.se" changes to "recompile.se".  This
-   also affects the D-Bus bus and interface names (old names still
-   work).  Users should start using the new names immediately.
-** New D-Bus Client object properties "Expires" and "ExtendedTimeout";
-   see DBUS-API for details.
-
 Version 1.3.1 (2011-07-27)
 * Client:
 ** Client now retries all Mandos servers periodically.

=== modified file 'TODO'
--- TODO	2011-11-09 17:16:03 +0000
+++ TODO	2011-09-26 19:36:18 +0000
@@ -16,7 +16,7 @@
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
-* usplash (Deprecated)
+* usplash
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
@@ -41,7 +41,8 @@
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
-  
+** TODO Persistent state						  :BUGS:
+   /var/lib/mandos/*
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
@@ -52,6 +53,8 @@
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
+** TODO Date+time on console log messages				  :BUGS:
+   Is this the default?
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given
@@ -63,8 +66,8 @@
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html
-   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
+** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
@@ -78,7 +81,6 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
-** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
@@ -112,8 +114,8 @@
    From XML sources directly?
 
 * Side Stuff
-** TODO Locate which package moves the other bin/sh when busybox is deactivated
-** TODO contact owner of package, and ask them to have that shell static in position regardless of busybox
+** TODO Locate which packet move the other bin/sh when busy box is deactivated
+** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
 
 
 #+STARTUP: showall

=== modified file 'common.ent'
--- common.ent	2011-10-15 16:48:03 +0000
+++ common.ent	2011-07-27 17:58:27 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.4.1">
+<!ENTITY version "1.3.1">

=== modified file 'debian/changelog'
--- debian/changelog	2011-10-15 16:48:03 +0000
+++ debian/changelog	2011-07-27 17:58:27 +0000
@@ -1,35 +1,3 @@
-mandos (1.4.1-1) unstable; urgency=low
-
-  * New upstream release.
-  * debian/control (Build-Depends): Added "man".
-  * debian/control (Conflicts): Changed to "Breaks:".
-  * debian/copyright: Updated format.
-  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
-  * debian/mandos-client.postrm: - '' -
-  * debian/mandos.postinst: - '' -
-  * debian/mandos.prerm: Consistent magic.
-
- -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
-
-mandos (1.4.0-1) unstable; urgency=low
-
-  * New upstream release.
-  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
-    LDFLAGS in Makefile. (Closes: #632145)
-  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
-    new PID file locations. (Closes: #643554)
-  * debian/source/local-options: New; contains "--single-debian-patch".
-  * debian/control (Standards-Version): Upgraded to "3.9.2".
-    (DM-Upload-Allowed): New; set to "yes".
-  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
-  * debian/copyright: - '' -
-  * debian/mandos-client.README.Debian: - '' -
-  * debian/mandos.README.Debian: - '' -
-  * debian/watch: - '' -
-  * debian/control (mandos/Description): Fix language to placate lintian.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200
-
 mandos (1.3.1-1) unstable; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2011-10-11 19:36:00 +0000
+++ debian/control	2011-10-05 16:00:56 +0000
@@ -6,12 +6,11 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config, man
-Standards-Version: 3.9.2
+	pkg-config
+Standards-Version: 3.9.1
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
-DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
@@ -38,7 +37,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
-Breaks: dropbear (<= 0.53.1-1)
+Conflicts: dropbear (<= 0.52-5)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2011-10-10 20:29:58 +0000
+++ debian/copyright	2011-10-05 16:00:56 +0000
@@ -1,7 +1,8 @@
-Format: http://anonscm.debian.org/viewvc/dep/web/deps/dep5.mdwn?revision=202
+Format-Specification:
+ http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
 Upstream-Name: Mandos
-Upstream-Contact: Mandos <mandos@recompile.se>
-Source: <http://www.recompile.se/mandos>
+Upstream-Maintainer: Mandos Maintainers <mandos@recompile.se>
+Upstream-Source: <http://www.recompile.se/mandos>
 
 Files: *
 Copyright: Copyright © 2008-2011 Teddy Hogeborn

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postinst	2009-05-24 23:36:15 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-set -e
-
 # Update the initial RAM file system image
 update_initramfs()
 {

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2011-10-10 20:29:58 +0000
+++ debian/mandos-client.postrm	2011-02-27 17:00:41 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was removed:
@@ -26,7 +26,6 @@
 # If preinst fails during upgrade:
 #       <new-postrm> abort-upgrade <old-version>
 
-set -e
 
 # Update the initial RAM file system image
 update_initramfs()

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2011-10-10 20:29:58 +0000
+++ debian/mandos.postinst	2009-05-24 23:28:04 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,8 +15,6 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
-set -e
-
 case "$1" in
     configure)
 	# Rename old "mandos" user and group

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2011-10-10 20:29:58 +0000
+++ debian/mandos.prerm	2009-01-18 00:16:57 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh
+#! /bin/sh
 # prerm script for mandos
 #
 # see: dh_installdeb(1)

=== removed file 'debian/source/local-options'
--- debian/source/local-options	2011-10-08 21:13:46 +0000
+++ debian/source/local-options	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
---single-debian-patch

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2011-10-05 16:56:06 +0000
+++ initramfs-tools-hook	2010-09-09 18:16:14 +0000
@@ -131,7 +131,7 @@
 	"${DESTDIR}${CONFDIR}/plugin-runner.conf"
 fi
 
-# Key files
+# Key files 
 for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue

=== modified file 'mandos'
--- mandos	2011-11-09 17:16:03 +0000
+++ mandos	2011-10-05 16:00:56 +0000
@@ -63,7 +63,6 @@
 import cPickle as pickle
 import multiprocessing
 import types
-import hashlib
 
 import dbus
 import dbus.service
@@ -74,7 +73,6 @@
 import ctypes.util
 import xml.dom.minidom
 import inspect
-import Crypto.Cipher.AES
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -85,11 +83,10 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.4.1"
-
-logger = logging.getLogger()
-stored_state_path = "/var/lib/mandos/clients.pickle"
-
+version = "1.3.1"
+
+#logger = logging.getLogger('mandos')
+logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = str("/dev/log")))
@@ -99,13 +96,11 @@
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
-console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                       ' [%(process)d]:'
+console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
                                        ' %(levelname)s:'
                                        ' %(message)s'))
 logger.addHandler(console)
 
-
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
@@ -165,10 +160,13 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server
-                            .GetAlternativeServiceName(self.name))
+        self.name = unicode(self.server.GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
+        syslogger.setFormatter(logging.Formatter
+                               ('Mandos (%s) [%%(process)d]:'
+                                ' %%(levelname)s: %%(message)s'
+                                % self.name))
         self.remove()
         try:
             self.add()
@@ -194,7 +192,7 @@
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
         self.entry_group_state_changed_match = (
             self.group.connect_to_signal(
-                'StateChanged', self.entry_group_state_changed))
+                'StateChanged', self .entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -266,15 +264,6 @@
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
-class AvahiServiceToSyslog(AvahiService):
-    def rename(self):
-        """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self)
-        syslogger.setFormatter(logging.Formatter
-                               ('Mandos (%s) [%%(process)d]:'
-                                ' %%(levelname)s: %%(message)s'
-                                % self.name))
-        return ret
 
 def _timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
@@ -299,9 +288,8 @@
                      instance %(name)s can be used in the command.
     checker_initiator_tag: a gobject event source tag, or None
     created:    datetime.datetime(); (UTC) object creation
-    client_structure: Object describing what attributes a client has
-                      and is used for storing the client at exit
     current_checker_command: string; current running checker_command
+    disable_hook:  If set, called by disable() as disable_hook(self)
     disable_initiator_tag: a gobject event source tag, or None
     enabled:    bool()
     fingerprint: string (40 or 32 hexadecimal digits); used to
@@ -310,9 +298,6 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
-    last_checker_status: integer between 0 and 255 reflecting exit status
-                         of last checker. -1 reflect crashed checker,
-                         or None.
     last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
@@ -336,7 +321,7 @@
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return _timedelta_to_milliseconds(self.extended_timeout)
+        return _timedelta_to_milliseconds(self.extended_timeout)    
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
@@ -345,7 +330,7 @@
     def approval_delay_milliseconds(self):
         return _timedelta_to_milliseconds(self.approval_delay)
     
-    def __init__(self, name = None, config=None):
+    def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
@@ -371,22 +356,22 @@
                             % self.name)
         self.host = config.get("host", "")
         self.created = datetime.datetime.utcnow()
-        self.enabled = True
+        self.enabled = False
         self.last_approval_request = None
-        self.last_enabled = datetime.datetime.utcnow()
+        self.last_enabled = None
         self.last_checked_ok = None
-        self.last_checker_status = None
         self.timeout = string_to_delta(config["timeout"])
-        self.extended_timeout = string_to_delta(config
-                                                ["extended_timeout"])
+        self.extended_timeout = string_to_delta(config["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
+        self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
-        self.expires = datetime.datetime.utcnow() + self.timeout
+        self.expires = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
+        self.last_connect = None
         self._approved = None
         self.approved_by_default = config.get("approved_by_default",
                                               True)
@@ -395,33 +380,33 @@
             config["approval_delay"])
         self.approval_duration = string_to_delta(
             config["approval_duration"])
-        self.changedstate = (multiprocessing_manager
-                             .Condition(multiprocessing_manager
-                                        .Lock()))
-        self.client_structure = [attr for attr in self.__dict__.iterkeys() if not attr.startswith("_")]
-        self.client_structure.append("client_structure")
-
-
-        for name, t in inspect.getmembers(type(self),
-                                          lambda obj: isinstance(obj, property)):
-            if not name.startswith("_"):
-                self.client_structure.append(name)
+        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
     
-    # Send notice to process children that client state has changed
     def send_changedstate(self):
-        with self.changedstate:
-            self.changedstate.notify_all()
-    
+        self.changedstate.acquire()
+        self.changedstate.notify_all()
+        self.changedstate.release()
+        
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, "enabled", False):
             # Already enabled
             return
         self.send_changedstate()
+        # Schedule a new checker to be started an 'interval' from now,
+        # and every interval from then on.
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (self.interval_milliseconds(),
+                                       self.start_checker))
+        # Schedule a disable() when 'timeout' has passed
         self.expires = datetime.datetime.utcnow() + self.timeout
+        self.disable_initiator_tag = (gobject.timeout_add
+                                   (self.timeout_milliseconds(),
+                                    self.disable))
         self.enabled = True
         self.last_enabled = datetime.datetime.utcnow()
-        self.init_checker()
+        # Also start a new checker *right now*.
+        self.start_checker()
     
     def disable(self, quiet=True):
         """Disable this client."""
@@ -439,34 +424,23 @@
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
+        if self.disable_hook:
+            self.disable_hook(self)
         self.enabled = False
         # Do not run this again if called by a gobject.timeout_add
         return False
     
     def __del__(self):
+        self.disable_hook = None
         self.disable()
-
-    def init_checker(self):
-        # Schedule a new checker to be started an 'interval' from now,
-        # and every interval from then on.
-        self.checker_initiator_tag = (gobject.timeout_add
-                                      (self.interval_milliseconds(),
-                                       self.start_checker))
-        # Schedule a disable() when 'timeout' has passed
-        self.disable_initiator_tag = (gobject.timeout_add
-                                   (self.timeout_milliseconds(),
-                                    self.disable))
-        # Also start a new checker *right now*.
-        self.start_checker()
-
-        
+    
     def checker_callback(self, pid, condition, command):
         """The checker has completed, so take appropriate actions."""
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            self.last_checker_status =  os.WEXITSTATUS(condition)
-            if self.last_checker_status == 0:
+            exitstatus = os.WEXITSTATUS(condition)
+            if exitstatus == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
                 self.checked_ok()
@@ -474,7 +448,6 @@
                 logger.info("Checker for %(name)s failed",
                             vars(self))
         else:
-            self.last_checker_status = -1
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
@@ -487,13 +460,11 @@
         if timeout is None:
             timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
-        if self.disable_initiator_tag is not None:
-            gobject.source_remove(self.disable_initiator_tag)
-        if getattr(self, "enabled", False):
-            self.disable_initiator_tag = (gobject.timeout_add
-                                          (_timedelta_to_milliseconds
-                                           (timeout), self.disable))
-            self.expires = datetime.datetime.utcnow() + timeout
+        gobject.source_remove(self.disable_initiator_tag)
+        self.expires = datetime.datetime.utcnow() + timeout
+        self.disable_initiator_tag = (gobject.timeout_add
+                                      (_timedelta_to_milliseconds(timeout),
+                                       self.disable))
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -591,52 +562,6 @@
                 raise
         self.checker = None
 
-    # Encrypts a client secret and stores it in a varible encrypted_secret
-    def encrypt_secret(self, key):
-        # Encryption-key need to be of a specific size, so we hash inputed key
-        hasheng = hashlib.sha256()
-        hasheng.update(key)
-        encryptionkey = hasheng.digest()
-
-        # Create validation hash so we know at decryption if it was sucessful
-        hasheng = hashlib.sha256()
-        hasheng.update(self.secret)
-        validationhash = hasheng.digest()
-
-        # Encrypt secret
-        iv = os.urandom(Crypto.Cipher.AES.block_size)
-        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
-                                        Crypto.Cipher.AES.MODE_CFB, iv)
-        ciphertext = ciphereng.encrypt(validationhash+self.secret)
-        self.encrypted_secret = (ciphertext, iv)
-
-    # Decrypt a encrypted client secret
-    def decrypt_secret(self, key):
-        # Decryption-key need to be of a specific size, so we hash inputed key
-        hasheng = hashlib.sha256()
-        hasheng.update(key)
-        encryptionkey = hasheng.digest()
-
-        # Decrypt encrypted secret
-        ciphertext, iv = self.encrypted_secret
-        ciphereng = Crypto.Cipher.AES.new(encryptionkey,
-                                        Crypto.Cipher.AES.MODE_CFB, iv)
-        plain = ciphereng.decrypt(ciphertext)
-
-        # Validate decrypted secret to know if it was succesful
-        hasheng = hashlib.sha256()
-        validationhash = plain[:hasheng.digest_size]
-        secret = plain[hasheng.digest_size:]
-        hasheng.update(secret)
-
-        # if validation fails, we use key as new secret. Otherwhise, we use
-        # the decrypted secret
-        if hasheng.digest() == validationhash:
-            self.secret = secret
-        else:
-            self.secret = key
-        del self.encrypted_secret
-
 
 def dbus_service_property(dbus_interface, signature="v",
                           access="readwrite", byte_arrays=False):
@@ -704,18 +629,15 @@
         """
         return ((prop.__get__(self)._dbus_name, prop.__get__(self))
                 for cls in self.__class__.__mro__
-                for name, prop in
-                inspect.getmembers(cls, self._is_dbus_property))
+                for name, prop in inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
         for cls in  self.__class__.__mro__:
-            for name, value in (inspect.getmembers
-                                (cls, self._is_dbus_property)):
-                if (value._dbus_name == property_name
-                    and value._dbus_interface == interface_name):
+            for name, value in inspect.getmembers(cls, self._is_dbus_property):
+                if value._dbus_name == property_name and value._dbus_interface == interface_name:
                     return value.__get__(self)
         
         # No such property
@@ -832,8 +754,7 @@
     return dbus.String(dt.isoformat(),
                        variant_level=variant_level)
 
-class AlternateDBusNamesMetaclass(DBusObjectWithProperties
-                                  .__metaclass__):
+class AlternateDBusNamesMetaclass(DBusObjectWithProperties.__metaclass__):
     """Applied to an empty subclass of a D-Bus object, this metaclass
     will add additional D-Bus attributes matching a certain pattern.
     """
@@ -943,10 +864,9 @@
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
+        self._approvals_pending = 0
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
-
-        self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
         client_object_name = unicode(self.name).translate(
@@ -963,27 +883,25 @@
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
 
-        transform_fun: Function that takes a value and a variant_level
-                       and transforms it to a D-Bus type.
+        transform_fun: Function that takes a value and transforms it
+                       to a D-Bus type.
         dbus_name: D-Bus name of the variable
         type_func: Function that transform the value before sending it
                    to the D-Bus.  Default: no transform
         variant_level: D-Bus variant level.  Default: 1
         """
-        attrname = "_{0}".format(dbus_name)
+        real_value = [None,]
         def setter(self, value):
+            old_value = real_value[0]
+            real_value[0] = value
             if hasattr(self, "dbus_object_path"):
-                if (not hasattr(self, attrname) or
-                    type_func(getattr(self, attrname, None))
-                    != type_func(value)):
-                    dbus_value = transform_func(type_func(value),
-                                                variant_level
-                                                =variant_level)
+                if type_func(old_value) != type_func(real_value[0]):
+                    dbus_value = transform_func(type_func(real_value[0]),
+                                                variant_level)
                     self.PropertyChanged(dbus.String(dbus_name),
                                          dbus_value)
-            setattr(self, attrname, value)
         
-        return property(lambda self: getattr(self, attrname), setter)
+        return property(lambda self: real_value[0], setter)
     
     
     expires = notifychangeproperty(datetime_to_dbus, "Expires")
@@ -994,32 +912,24 @@
     last_enabled = notifychangeproperty(datetime_to_dbus,
                                         "LastEnabled")
     checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
-                                   type_func = lambda checker:
-                                       checker is not None)
+                                   type_func = lambda checker: checker is not None)
     last_checked_ok = notifychangeproperty(datetime_to_dbus,
                                            "LastCheckedOK")
-    last_approval_request = notifychangeproperty(
-        datetime_to_dbus, "LastApprovalRequest")
+    last_approval_request = notifychangeproperty(datetime_to_dbus,
+                                                 "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt16,
-                                          "ApprovalDelay",
-                                          type_func =
-                                          _timedelta_to_milliseconds)
-    approval_duration = notifychangeproperty(
-        dbus.UInt16, "ApprovalDuration",
-        type_func = _timedelta_to_milliseconds)
+    approval_delay = notifychangeproperty(dbus.UInt16, "ApprovalDelay",
+                                          type_func = _timedelta_to_milliseconds)
+    approval_duration = notifychangeproperty(dbus.UInt16, "ApprovalDuration",
+                                             type_func = _timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
     timeout = notifychangeproperty(dbus.UInt16, "Timeout",
-                                   type_func =
-                                   _timedelta_to_milliseconds)
-    extended_timeout = notifychangeproperty(
-        dbus.UInt16, "ExtendedTimeout",
-        type_func = _timedelta_to_milliseconds)
-    interval = notifychangeproperty(dbus.UInt16,
-                                    "Interval",
-                                    type_func =
-                                    _timedelta_to_milliseconds)
+                                   type_func = _timedelta_to_milliseconds)
+    extended_timeout = notifychangeproperty(dbus.UInt16, "ExtendedTimeout",
+                                            type_func = _timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt16, "Interval",
+                                    type_func = _timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1260,18 +1170,18 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = _timedelta_to_milliseconds((self
-                                                  .last_checked_ok
-                                                  + self.timeout)
-                                                 - datetime.datetime
-                                                 .utcnow())
+        time_to_die = (self.
+                       _timedelta_to_milliseconds((self
+                                                   .last_checked_ok
+                                                   + self.timeout)
+                                                  - datetime.datetime
+                                                  .utcnow()))
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
         else:
             self.expires = (datetime.datetime.utcnow()
-                            + datetime.timedelta(milliseconds =
-                                                 time_to_die))
+                            + datetime.timedelta(milliseconds = time_to_die))
             self.disable_initiator_tag = (gobject.timeout_add
                                           (time_to_die, self.disable))
     
@@ -1443,7 +1353,7 @@
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")
+                            client.Rejected("Disabled")                    
                         return
                     
                     if client._approved or not client.approval_delay:
@@ -1466,11 +1376,10 @@
                         return
                     
                     #wait until timeout or approved
+                    #x = float(client._timedelta_to_milliseconds(delay))
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    (client.changedstate.wait
-                     (float(client._timedelta_to_milliseconds(delay)
-                            / 1000)))
+                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1500,7 +1409,7 @@
                     sent_size += sent
                 
                 logger.info("Sending secret to %s", client.name)
-                # bump the timeout using extended_timeout
+                # bump the timeout as if seen
                 client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
@@ -1586,14 +1495,11 @@
         except:
             self.handle_error(request, address)
         self.close_request(request)
-    
+            
     def process_request(self, request, address):
         """Start a new process to process the request."""
-        proc = multiprocessing.Process(target = self.sub_process_main,
-                                       args = (request,
-                                               address))
-        proc.start()
-        return proc
+        multiprocessing.Process(target = self.sub_process_main,
+                                args = (request, address)).start()
 
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
@@ -1605,12 +1511,12 @@
         """
         parent_pipe, self.child_pipe = multiprocessing.Pipe()
         
-        proc = MultiprocessingMixIn.process_request(self, request,
-                                                    client_address)
+        super(MultiprocessingMixInWithPipe,
+              self).process_request(request, client_address)
         self.child_pipe.close()
-        self.add_pipe(parent_pipe, proc)
+        self.add_pipe(parent_pipe)
     
-    def add_pipe(self, parent_pipe, proc):
+    def add_pipe(self, parent_pipe):
         """Dummy function; override as necessary"""
         raise NotImplementedError
 
@@ -1694,7 +1600,7 @@
         self.enabled = False
         self.clients = clients
         if self.clients is None:
-            self.clients = {}
+            self.clients = set()
         self.use_dbus = use_dbus
         self.gnutls_priority = gnutls_priority
         IPv6_TCPServer.__init__(self, server_address,
@@ -1704,21 +1610,17 @@
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
-    
     def enable(self):
         self.enabled = True
-    
-    def add_pipe(self, parent_pipe, proc):
+    def add_pipe(self, parent_pipe):
         # Call "handle_ipc" for both data and EOF events
         gobject.io_add_watch(parent_pipe.fileno(),
                              gobject.IO_IN | gobject.IO_HUP,
                              functools.partial(self.handle_ipc,
-                                               parent_pipe =
-                                               parent_pipe,
-                                               proc = proc))
-    
+                                               parent_pipe = parent_pipe))
+        
     def handle_ipc(self, source, condition, parent_pipe=None,
-                   proc = None, client_object=None):
+                   client_object=None):
         condition_names = {
             gobject.IO_IN: "IN",   # There is data to read.
             gobject.IO_OUT: "OUT", # Data can be written (without
@@ -1733,10 +1635,8 @@
                                        for cond, name in
                                        condition_names.iteritems()
                                        if cond & condition)
-        # error, or the other end of multiprocessing.Pipe has closed
+        # error or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
-            # Wait for other process to exit
-            proc.join()
             return False
         
         # Read a request from the child
@@ -1747,7 +1647,7 @@
             fpr = request[1]
             address = request[2]
             
-            for c in self.clients.itervalues():
+            for c in self.clients:
                 if c.fingerprint == fpr:
                     client = c
                     break
@@ -1756,39 +1656,31 @@
                             "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr,
-                                                       address[0])
+                    mandos_dbus_service.ClientNotFound(fpr, address[0])
                 parent_pipe.send(False)
                 return False
             
             gobject.io_add_watch(parent_pipe.fileno(),
                                  gobject.IO_IN | gobject.IO_HUP,
                                  functools.partial(self.handle_ipc,
-                                                   parent_pipe =
-                                                   parent_pipe,
-                                                   proc = proc,
-                                                   client_object =
-                                                   client))
+                                                   parent_pipe = parent_pipe,
+                                                   client_object = client))
             parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on
-            # same fileno
+            # remove the old hook in favor of the new above hook on same fileno
             return False
         if command == 'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
             
-            parent_pipe.send(('data', getattr(client_object,
-                                              funcname)(*args,
-                                                         **kwargs)))
+            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
         
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
                 parent_pipe.send(('function',))
             else:
-                parent_pipe.send(('data', client_object
-                                  .__getattribute__(attrname)))
+                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
@@ -1921,10 +1813,6 @@
                         " system bus interface")
     parser.add_argument("--no-ipv6", action="store_false",
                         dest="use_ipv6", help="Do not use IPv6")
-    parser.add_argument("--no-restore", action="store_false",
-                        dest="restore", help="Do not restore stored state",
-                        default=True)
-
     options = parser.parse_args()
     
     if options.check:
@@ -1965,7 +1853,7 @@
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus", "use_ipv6", "debuglevel", "restore"):
+                   "use_dbus", "use_ipv6", "debuglevel"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -2044,13 +1932,14 @@
             raise error
     
     if not debug and not debuglevel:
-        logger.setLevel(logging.WARNING)
+        syslogger.setLevel(logging.WARNING)
+        console.setLevel(logging.WARNING)
     if debuglevel:
         level = getattr(logging, debuglevel.upper())
-        logger.setLevel(level)
+        syslogger.setLevel(level)
+        console.setLevel(level)
     
     if debug:
-        logger.setLevel(logging.DEBUG)
         # Enable all possible GnuTLS debugging
         
         # "Use a log level over 10 to enable all debugging options."
@@ -2088,19 +1977,17 @@
         try:
             bus_name = dbus.service.BusName("se.recompile.Mandos",
                                             bus, do_not_queue=True)
-            old_bus_name = (dbus.service.BusName
-                            ("se.bsnet.fukt.Mandos", bus,
-                             do_not_queue=True))
+            old_bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
+                                                bus, do_not_queue=True)
         except dbus.exceptions.NameExistsException as e:
             logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
             server_settings["use_dbus"] = False
             tcp_server.use_dbus = False
     protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
-    service = AvahiServiceToSyslog(name =
-                                   server_settings["servicename"],
-                                   servicetype = "_mandos._tcp",
-                                   protocol = protocol, bus = bus)
+    service = AvahiService(name = server_settings["servicename"],
+                           servicetype = "_mandos._tcp",
+                           protocol = protocol, bus = bus)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (str(server_settings["interface"])))
@@ -2110,104 +1997,24 @@
     
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBusTransitional,
-                                         bus = bus)
-    
-    special_settings = {
-        # Some settings need to be accessd by special methods;
-        # booleans need .getboolean(), etc.  Here is a list of them:
-        "approved_by_default":
-            lambda section:
-            client_config.getboolean(section, "approved_by_default"),
-        }
-    # Construct a new dict of client settings of this form:
-    # { client_name: {setting_name: value, ...}, ...}
-    # with exceptions for any special settings as defined above
-    client_settings = dict((clientname,
-                           dict((setting,
-                                 (value if setting not in special_settings
-                                  else special_settings[setting](clientname)))
-                                for setting, value in client_config.items(clientname)))
-                          for clientname in client_config.sections())
-    
-    old_client_settings = {}
-    clients_data = []
-
-    # Get client data and settings from last running state. 
-    if server_settings["restore"]:
-        try:
-            with open(stored_state_path, "rb") as stored_state:
-                clients_data, old_client_settings = pickle.load(stored_state)
-            os.remove(stored_state_path)
-        except IOError as e:
-            logger.warning("Could not load persistant state: {0}".format(e))
-            if e.errno != errno.ENOENT:
-                raise
-
-    for client in clients_data:
-        client_name = client["name"]
-        
-        # Decide which value to use after restoring saved state.
-        # We have three different values: Old config file,
-        # new config file, and saved state.
-        # New config value takes precedence if it differs from old
-        # config value, otherwise use saved state.
-        for name, value in client_settings[client_name].items():
+        client_class = functools.partial(ClientDBusTransitional, bus = bus)        
+    def client_config_items(config, section):
+        special_settings = {
+            "approved_by_default":
+                lambda: config.getboolean(section,
+                                          "approved_by_default"),
+            }
+        for name, value in config.items(section):
             try:
-                # For each value in new config, check if it differs
-                # from the old config value (Except for the "secret"
-                # attribute)
-                if name != "secret" and value != old_client_settings[client_name][name]:
-                    setattr(client, name, value)
+                yield (name, special_settings[name]())
             except KeyError:
-                pass
-
-        # Clients who has passed its expire date, can still be enabled if its
-        # last checker was sucessful. Clients who checkers failed before we
-        # stored it state is asumed to had failed checker during downtime.
-        if client["enabled"] and client["last_checked_ok"]:
-            if ((datetime.datetime.utcnow() - client["last_checked_ok"])
-                > client["interval"]):
-                if client["last_checker_status"] != 0:
-                    client["enabled"] = False
-                else:
-                    client["expires"] = datetime.datetime.utcnow() + client["timeout"]
-
-        client["changedstate"] = (multiprocessing_manager
-                                  .Condition(multiprocessing_manager
-                                             .Lock()))
-        if use_dbus:
-            new_client = ClientDBusTransitional.__new__(ClientDBusTransitional)
-            tcp_server.clients[client_name] = new_client
-            new_client.bus = bus
-            for name, value in client.iteritems():
-                setattr(new_client, name, value)
-            client_object_name = unicode(client_name).translate(
-                {ord("."): ord("_"),
-                 ord("-"): ord("_")})
-            new_client.dbus_object_path = (dbus.ObjectPath
-                                     ("/clients/" + client_object_name))
-            DBusObjectWithProperties.__init__(new_client,
-                                              new_client.bus,
-                                              new_client.dbus_object_path)
-        else:
-            tcp_server.clients[client_name] = Client.__new__(Client)
-            for name, value in client.iteritems():
-                setattr(tcp_server.clients[client_name], name, value)
-                
-        tcp_server.clients[client_name].decrypt_secret(
-            client_settings[client_name]["secret"])            
-        
-    # Create/remove clients based on new changes made to config
-    for clientname in set(old_client_settings) - set(client_settings):
-        del tcp_server.clients[clientname]
-    for clientname in set(client_settings) - set(old_client_settings):
-        tcp_server.clients[clientname] = (client_class(name = clientname,
-                                                       config =
-                                                       client_settings
-                                                       [clientname]))
+                yield (name, value)
     
-
+    tcp_server.clients.update(set(
+            client_class(name = section,
+                         config= dict(client_config_items(
+                        client_config, section)))
+            for section in client_config.sections()))
     if not tcp_server.clients:
         logger.warning("No clients defined")
         
@@ -2256,8 +2063,7 @@
             def GetAllClients(self):
                 "D-Bus method"
                 return dbus.Array(c.dbus_object_path
-                                  for c in
-                                  tcp_server.clients.itervalues())
+                                  for c in tcp_server.clients)
             
             @dbus.service.method(_interface,
                                  out_signature="a{oa{sv}}")
@@ -2265,15 +2071,15 @@
                 "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAll(""))
-                     for c in tcp_server.clients.itervalues()),
+                     for c in tcp_server.clients),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
                 "D-Bus method"
-                for c in tcp_server.clients.itervalues():
+                for c in tcp_server.clients:
                     if c.dbus_object_path == object_path:
-                        del tcp_server.clients[c.name]
+                        tcp_server.clients.remove(c)
                         c.remove_from_connection()
                         # Don't signal anything except ClientRemoved
                         c.disable(quiet=True)
@@ -2292,64 +2098,25 @@
         "Cleanup function; run on exit"
         service.cleanup()
         
-        multiprocessing.active_children()
-        if not (tcp_server.clients or client_settings):
-            return
-
-        # Store client before exiting. Secrets are encrypted with key based
-        # on what config file has. If config file is removed/edited, old
-        # secret will thus be unrecovable.
-        clients = []
-        for client in tcp_server.clients.itervalues():
-            client.encrypt_secret(client_settings[client.name]["secret"])
-
-            client_dict = {}
-
-            # A list of attributes that will not be stored when shuting down.
-            exclude = set(("bus", "changedstate", "secret"))            
-            for name, typ in inspect.getmembers(dbus.service.Object):
-                exclude.add(name)
-                
-            client_dict["encrypted_secret"] = client.encrypted_secret
-            for attr in client.client_structure:
-                if attr not in exclude:
-                    client_dict[attr] = getattr(client, attr)
-
-            clients.append(client_dict) 
-            del client_settings[client.name]["secret"]
-            
-        try:
-            with os.fdopen(os.open(stored_state_path, os.O_CREAT|os.O_WRONLY|os.O_TRUNC, 0600), "wb") as stored_state:
-                pickle.dump((clients, client_settings), stored_state)
-        except IOError as e:
-            logger.warning("Could not save persistant state: {0}".format(e))
-            if e.errno != errno.ENOENT:
-                raise
-
-        # Delete all clients, and settings from config
         while tcp_server.clients:
-            name, client = tcp_server.clients.popitem()
+            client = tcp_server.clients.pop()
             if use_dbus:
                 client.remove_from_connection()
+            client.disable_hook = None
             # Don't signal anything except ClientRemoved
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client
-                                                  .dbus_object_path,
+                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
                                                   client.name)
-        client_settings.clear()
     
     atexit.register(cleanup)
     
-    for client in tcp_server.clients.itervalues():
+    for client in tcp_server.clients:
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path)
-        # Need to initiate checking of clients
-        if client.enabled:
-            client.init_checker()
-
+        client.enable()
     
     tcp_server.enable()
     tcp_server.server_activate()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
+++ mandos-clients.conf.xml	2011-10-05 16:00:56 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-10-10">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -190,7 +190,7 @@
 	  </para>
 	  <para>
 	    Extended timeout is an added timeout that is given once
-	    after a password has been sent successfully to a client.
+	    after a password has been sent sucessfully to a client.
 	    The timeout is by default longer than the normal timeout,
 	    and is used for handling the extra long downtime while a
 	    machine is booting up.  Time to take into consideration

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-10-15 16:48:03 +0000
+++ mandos-ctl	2011-10-05 16:00:56 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2011 Teddy Hogeborn
-# Copyright © 2008-2011 Björn Påhlsson
+# Copyright © 2008-2010 Teddy Hogeborn
+# Copyright © 2008-2010 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -60,7 +60,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.4.1"
+version = "1.3.1"
 
 def timedelta_to_milliseconds(td):
     """Convert a datetime.timedelta object to milliseconds"""
@@ -301,41 +301,41 @@
                                          dbus_interface=
                                          dbus.PROPERTIES_IFACE)
                          else 1)
-            if options.checker is not None:
+            if options.checker:
                 client.Set(client_interface, "Checker",
                            options.checker,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.host is not None:
+            if options.host:
                 client.Set(client_interface, "Host", options.host,
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.interval is not None:
+            if options.interval:
                 client.Set(client_interface, "Interval",
                            timedelta_to_milliseconds
                            (string_to_delta(options.interval)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_delay is not None:
+            if options.approval_delay:
                 client.Set(client_interface, "ApprovalDelay",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_delay)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.approval_duration is not None:
+            if options.approval_duration:
                 client.Set(client_interface, "ApprovalDuration",
                            timedelta_to_milliseconds
                            (string_to_delta(options.
                                             approval_duration)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.timeout is not None:
+            if options.timeout:
                 client.Set(client_interface, "Timeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.extended_timeout is not None:
+            if options.extended_timeout:
                 client.Set(client_interface, "ExtendedTimeout",
                            timedelta_to_milliseconds
                            (string_to_delta(options.extended_timeout)),
                            dbus_interface=dbus.PROPERTIES_IFACE)
-            if options.secret is not None:
+            if options.secret:
                 client.Set(client_interface, "Secret",
                            dbus.ByteArray(open(options.secret,
                                                "rb").read()),

=== modified file 'mandos-keygen'
--- mandos-keygen	2011-10-15 16:48:03 +0000
+++ mandos-keygen	2011-10-05 16:00:56 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.4.1"
+VERSION="1.3.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-10-15 16:48:03 +0000
+++ mandos-monitor	2011-10-05 16:00:56 +0000
@@ -52,7 +52,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.4.1"
+version = "1.3.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2011-11-09 17:16:03 +0000
+++ mandos-options.xml	2009-02-13 05:38:21 +0000
@@ -85,10 +85,5 @@
     to the server if this option is turned off.  <emphasis>Only
     advanced users should consider changing this option</emphasis>.
   </para>
-
-  <para id="restore">
-    This option controls whether the server will restore any state from
-    last time it ran. Default is to try restore last state.
-  </para>
   
 </section>

=== modified file 'mandos.lsm'
--- mandos.lsm	2011-10-15 16:48:03 +0000
+++ mandos.lsm	2011-10-05 16:00:56 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.4.1
-Entered-date:	2011-10-15
+Version:	1.3.1
+Entered-date:	2011-07-27
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site: http://www.recompile.se/mandos
-	      138K mandos_1.4.1.orig.tar.gz
+	      136K mandos_1.3.1.orig.tar.gz
 Alternate-site: ftp://ftp.recompile.se/pub/mandos
-		138K mandos_1.4.1.orig.tar.gz
+		136K mandos_1.3.1.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.

=== modified file 'mandos.xml'
--- mandos.xml	2011-11-09 17:16:03 +0000
+++ mandos.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2011-10-22">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -94,8 +94,6 @@
       <arg><option>--no-dbus</option></arg>
       <sbr/>
       <arg><option>--no-ipv6</option></arg>
-      <sbr/>
-      <arg><option>--no-restore</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -277,13 +275,6 @@
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
-      
-      <varlistentry>
-	<term><option>--no-restore</option></term>
-	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="restore"/>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   
@@ -518,6 +509,9 @@
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
+      The console log messages do not show a time stamp.
+    </para>
+    <para>
       This server does not check the expire time of clients’ OpenPGP
       keys.
     </para>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-10-09 12:32:13 +0000
+++ plugin-runner.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2011 Teddy Hogeborn
- * Copyright © 2008-2011 Björn Påhlsson
+ * Copyright © 2008-2010 Teddy Hogeborn
+ * Copyright © 2008-2010 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2011-10-05 16:56:06 +0000
+++ plugin-runner.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2011-10-05">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -261,7 +261,7 @@
 	    Disable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  The plugin will not be
 	    started.
-	  </para>
+	  </para>	
 	</listitem>
       </varlistentry>
       

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
+++ plugins.d/password-prompt.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2011 Teddy Hogeborn
- * Copyright © 2008-2011 Björn Påhlsson
+ * Copyright © 2008-2010 Teddy Hogeborn
+ * Copyright © 2008-2010 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as

